import png, struct, os, math, pdb
import decompress_FALCOM

xy = True   #Set to true for xy swizzle order
xy = False  #Set to false for yx swizzle order

def split(s):
    with open(s, 'rb') as f:
        eof = f.seek(0, 2)
        f.seek(0x4)
        width, height, dummy, size = struct.unpack('<IIII', f.read(16))
        f.seek(0x10)
        palette = decompress_FALCOM.decompress_FALCOM3(f.read(size + 4))
        bitmap = bytearray()
        while f.tell() < eof:
            pos = f.tell()
            size = struct.unpack('<I', f.read(4))[0]
            f.seek(pos)
            bitmap += decompress_FALCOM.decompress_FALCOM3(f.read(size + 4))
    return width, height, bitmap, palette

def chunks(l, n):
    """Yield successive n-sized chunks from l."""
    for i in range(0, len(l), n):
        yield l[i:i + n]

def itpcnv(s):
    '''Converts ITPv?? image [YsCelceta] to PNG.'''
    global readoffset
    print(s)
    width, height, bitmap, palette = split(s)
    if palette == None:                                                                 #Some ITPs don't have palette data
        print('No palette data found in {}.'.format(s))                                 #I don't know how to decode those
        return
    if math.log(width, 2).is_integer() == False or math.log(height, 2).is_integer() == False:   #Checking for power-of-two dimensions
        print('Invalid dimensions: {}x{}'.format(width, height))
        return
        
##    with open('bitmap.bin', 'wb') as f:   #For writing the bitmap and palette data to separate files if you want
##        f.write(bitmap)
##    with open('palette.bin', 'wb') as f:
##        f.write(palette)
    buffer = bytearray(len(bitmap))         #Output buffer
    tilew = 32
    tileh = 32
    tilerows = height // tileh
    tilecols = width // tilew
    pos = 0
    for tilerow in range(tilerows):
        offset = width * tileh * tilerow
        for tilecol in range(tilecols):
            for row in range(tileh):
                base = tilecol * tilew + row * width + offset
                buffer[base:base + 32] = bitmap[pos:pos + 32]
                pos += 32
            
            
    p = list(chunks(buffer, width))
    with open(os.path.splitext(s)[0] + '.png', 'wb') as f:
        w = png.Writer(len(p[0]), len(p), palette=list(chunks(palette, 4)))
        w.write(f, p)
import os
for dirpath, dirnames, filenames in os.walk('.'):
    for filename in filenames:
        if os.path.splitext(filename)[1] == '.itp':
            try:
                itpcnv(dirpath + '\\' + filename)
            except Exception:
                print('Failed: {}'.format(dirpath + '\\' + filename))
##itpcnv('system\\m_thum02.itp')
